	.module FMeter.c
	.area text(rom, con, rel)
	.dbfile C:\DATA\FrequancyCounter\Code\FMeter.c
	.dbfunc e Delay _Delay fV
;              j -> R20,R21
;              i -> R22,R23
;            del -> R16,R17
	.even
_Delay::
	rcall push_gset2
	.dbline -1
	.dbline 57
; //**************************************************************************
; // Frequancy Meter
; // Version 1.0 Mars 2003
; //
; // 1.0 -> -First Release 
; //		  
; // 
; // Sylvain Bissonnette
; //**************************************************************************
; 
; 
; /*********************************************************/
; /*                   I N C L U D E    		             */
; /*********************************************************/	
; #include "macros.h"
; #include "iom8v.h"
; #include <stdio.h>
; #include <stdlib.h>
; #include <STRING.H>
; #include "NokiaLCD.h"
; 
; /*********************************************************/
; /*                   E X T E R N    		             */
; /*********************************************************/	
; extern char UpdateLcd; 
; 
; /*********************************************************/
; /*                   P R O T O T Y P E 		             */
; /*********************************************************/	
; void Delay(int del);
; void timer1_compa_isr(void);
; void timer0_ovf_isr(void);
; void GetCount(void);
; void PrintFreq(void);
; void Presentation(void);
; void main(void);
; 
; /*********************************************************/
; /*                   D E F I N E    		             */
; /*********************************************************/	
; #define  TRUE       1
; #define  FALSE	    0
; 
; #define	 CLR		0x20
; #define	 OEH		0x10
; #define  OEM		0x08
; #define	 OEL 		0x04
; 
; /*********************************************************/
; /*           G L O B A L    V A R I A B L E S			 */
; /*********************************************************/	
; unsigned long Count;
; unsigned long Time;
; 
; /*********************************************************/
; void Delay(int del)
; {
	.dbline 60
; int i,j;
; 
; for (j=0;j<del;j++)
	clr R20
	clr R21
	rjmp L8
L5:
	.dbline 61
; 	{
	.dbline 62
	clr R22
	clr R23
L9:
	.dbline 62
L10:
	.dbline 62
	subi R22,255  ; offset = 1
	sbci R23,255
	.dbline 62
	cpi R22,64
	ldi R30,1
	cpc R23,R30
	brlt L9
	.dbline 63
L6:
	.dbline 60
	subi R20,255  ; offset = 1
	sbci R21,255
L8:
	.dbline 60
	cp R20,R16
	cpc R21,R17
	brlt L5
	.dbline -2
	.dbline 64
; 	for (i=0;i<320;i++);
; 	}
; }
L4:
	rcall pop_gset2
	.dbline 0 ; func end
	ret
	.dbsym r j 20 I
	.dbsym r i 22 I
	.dbsym r del 16 I
	.dbend
	.area vector(rom, abs)
	.org 12
	rjmp _timer1_compa_isr
	.area text(rom, con, rel)
	.dbfile C:\DATA\FrequancyCounter\Code\FMeter.c
	.dbfunc e timer1_compa_isr _timer1_compa_isr fV
	.even
_timer1_compa_isr::
	rcall push_lset
	.dbline -1
	.dbline 69
	.dbline 70
	in R24,0x16
	andi R24,2
	cpi R24,2
	brne L14
	.dbline 71
	.dbline 72
	rcall _GetCount
	.dbline 73
	rcall _PrintFreq
	.dbline 74
L14:
	.dbline -2
	.dbline 75
; 
; /*********************************************************/
; #pragma interrupt_handler timer1_compa_isr:7
; void timer1_compa_isr(void)
; {
; if ((PINB & 0x02) == 0x02)
;    {
;    GetCount();
;    PrintFreq();
;    }
; }
L13:
	rcall pop_lset
	.dbline 0 ; func end
	reti
	.dbend
	.area vector(rom, abs)
	.org 18
	rjmp _timer0_ovf_isr
	.area text(rom, con, rel)
	.dbfile C:\DATA\FrequancyCounter\Code\FMeter.c
	.dbfunc e timer0_ovf_isr _timer0_ovf_isr fV
	.even
_timer0_ovf_isr::
	rcall push_lset
	.dbline -1
	.dbline 80
	.dbline 81
	lds R24,_UpdateLcd
	cpi R24,1
	brne L17
	.dbline 81
	rcall _LcdUpdate
L17:
	.dbline -2
	.dbline 82
; 
; /*********************************************************/
; #pragma interrupt_handler timer0_ovf_isr:10
; void timer0_ovf_isr(void)
; {
; if (UpdateLcd == TRUE) LcdUpdate();
; }
L16:
	rcall pop_lset
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e GetCount _GetCount fV
	.even
_GetCount::
	rcall push_gset2
	.dbline -1
	.dbline 86
; 
; /*********************************************************/
; void GetCount(void)
; {
	.dbline 87
; Count = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	sts _Count+1,R21
	sts _Count,R20
	sts _Count+2+1,R23
	sts _Count+2,R22
	.dbline 89
; 
; PORTD &= ~OEH;
	cbi 0x12,4
	.dbline 90
; Delay(1);
	ldi R16,1
	ldi R17,0
	rcall _Delay
	.dbline 91
; Count = (unsigned long)((PINC & 0x3f) + (PIND & 0xc0));
	in R24,0x10
	clr R25
	andi R24,192
	andi R25,0
	in R30,0x13
	clr R31
	andi R30,63
	andi R31,0
	add R30,R24
	adc R31,R25
	movw R2,R30
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	sts _Count+1,R3
	sts _Count,R2
	sts _Count+2+1,R5
	sts _Count+2,R4
	.dbline 92
; PORTD |= OEH;
	sbi 0x12,4
	.dbline 94
; 
; Count = Count << 8;
	ldi R24,8
	ldi R25,0
	st -y,R24
	movw R16,R2
	movw R18,R4
	rcall lsl32
	sts _Count+1,R17
	sts _Count,R16
	sts _Count+2+1,R19
	sts _Count+2,R18
	.dbline 96
; 
; PORTD &= ~OEM;
	cbi 0x12,3
	.dbline 97
; Delay(1);
	ldi R16,1
	ldi R17,0
	rcall _Delay
	.dbline 98
; Count += (unsigned long)((PINC & 0x3f) + (PIND & 0xc0));
	in R24,0x10
	clr R25
	andi R24,192
	andi R25,0
	in R30,0x13
	clr R31
	andi R30,63
	andi R31,0
	add R30,R24
	adc R31,R25
	movw R2,R30
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	lds R8,_Count+2
	lds R9,_Count+2+1
	lds R6,_Count
	lds R7,_Count+1
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	sts _Count+1,R7
	sts _Count,R6
	sts _Count+2+1,R9
	sts _Count+2,R8
	.dbline 99
; PORTD |= OEM;
	sbi 0x12,3
	.dbline 101
; 
; Count = Count << 8;
	ldi R24,8
	ldi R25,0
	st -y,R24
	movw R16,R6
	movw R18,R8
	rcall lsl32
	sts _Count+1,R17
	sts _Count,R16
	sts _Count+2+1,R19
	sts _Count+2,R18
	.dbline 103
; 
; PORTD &= ~OEL;
	cbi 0x12,2
	.dbline 104
; Delay(1);
	ldi R16,1
	ldi R17,0
	rcall _Delay
	.dbline 105
; Count += (unsigned long)((PINC & 0x3f) + (PIND & 0xc0));
	in R24,0x10
	clr R25
	andi R24,192
	andi R25,0
	in R30,0x13
	clr R31
	andi R30,63
	andi R31,0
	add R30,R24
	adc R31,R25
	movw R2,R30
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	lds R8,_Count+2
	lds R9,_Count+2+1
	lds R6,_Count
	lds R7,_Count+1
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	sts _Count+1,R7
	sts _Count,R6
	sts _Count+2+1,R9
	sts _Count+2,R8
	.dbline 106
; PORTD |= OEL;
	sbi 0x12,2
	.dbline 108
; 
; PORTD &= ~CLR;
	cbi 0x12,5
	.dbline 109
; Delay(1);
	ldi R16,1
	ldi R17,0
	rcall _Delay
	.dbline 110
; PORTD |= CLR;
	sbi 0x12,5
	.dbline -2
	.dbline 111
; }
L19:
	rcall pop_gset2
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e PrintFreq _PrintFreq fV
;            Len -> R10
;            Str -> y+11
;            Tmp -> y+4
	.even
_PrintFreq::
	rcall push_gset3
	sbiw R28,18
	.dbline -1
	.dbline 116
; 
; 
; /*********************************************************/
; void PrintFreq(void)
; {
	.dbline 121
; char Str[7];
; char Tmp[7];
; unsigned char Len;
; 
; LcdGotoXY(1,4);
	ldi R18,4
	ldi R16,1
	rcall _LcdGotoXY
	.dbline 122
; LcdStr(2,"      ");
	ldi R18,<L21
	ldi R19,>L21
	ldi R16,2
	rcall _LcdStr
	.dbline 123
; LcdGotoXY(2,4);
	ldi R18,4
	ldi R16,2
	rcall _LcdGotoXY
	.dbline 124
; LcdStr(2,"     ");   
	ldi R18,<L22
	ldi R19,>L22
	ldi R16,2
	rcall _LcdStr
	.dbline 126
; 
; ltoa(&Str[0],Count,10);
	ldi R24,10
	ldi R25,0
	std y+2,R24
	std y+3,R25
	lds R4,_Count+2
	lds R5,_Count+2+1
	lds R2,_Count
	lds R3,_Count+1
	std y+0,R4
	std y+1,R5
	mov R18,R2
	mov R19,R3
	movw R16,R28
	subi R16,245  ; offset = 11
	sbci R17,255
	rcall _ltoa
	.dbline 127
; Len = strlen(&Str[0]);
	movw R16,R28
	subi R16,245  ; offset = 11
	sbci R17,255
	rcall _strlen
	mov R10,R16
	.dbline 128
; Str[Len] = 0x00;
	movw R24,R28
	adiw R24,11
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	clr R2
	std z+0,R2
	.dbline 130
; 
; if (Count < 1000)
	ldi R20,232
	ldi R21,3
	ldi R22,0
	ldi R23,0
	lds R4,_Count+2
	lds R5,_Count+2+1
	lds R2,_Count
	lds R3,_Count+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brlo X0
	rjmp L23
X0:
	.dbline 131
;    {
	.dbline 132
;    LcdGotoXY(12-(2*Len),4);
	ldi R18,4
	ldi R24,2
	mul R24,R10
	ldi R16,12
	sub R16,R0
	rcall _LcdGotoXY
	.dbline 133
;    LcdStr(2,&Str[0]);
	movw R18,R28
	subi R18,245  ; offset = 11
	sbci R19,255
	ldi R16,2
	rcall _LcdStr
	.dbline 134
;    LcdGotoXY(13,3);
	ldi R18,3
	ldi R16,13
	rcall _LcdGotoXY
	.dbline 135
;    LcdStr(1," " );
	ldi R18,<L25
	ldi R19,>L25
	ldi R16,1
	rcall _LcdStr
	.dbline 137
;    
;    Time = 100000 / Count;
	lds R4,_Count+2
	lds R5,_Count+2+1
	lds R2,_Count
	lds R3,_Count+1
	ldi R20,160
	ldi R21,134
	ldi R22,1
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	rcall div32u
	sts _Time+1,R17
	sts _Time,R16
	sts _Time+2+1,R19
	sts _Time+2,R18
	.dbline 138
;    ltoa(&Str[0],Time,10);
	ldi R24,10
	ldi R25,0
	std y+2,R24
	std y+3,R25
	std y+0,R18
	std y+1,R19
	mov R18,R16
	mov R19,R17
	movw R16,R28
	subi R16,245  ; offset = 11
	sbci R17,255
	rcall _ltoa
	.dbline 140
; 
;    if (Count <= 1000)
	ldi R20,232
	ldi R21,3
	ldi R22,0
	ldi R23,0
	lds R4,_Count+2
	lds R5,_Count+2+1
	lds R2,_Count
	lds R3,_Count+1
	cp R20,R2
	cpc R21,R3
	cpc R22,R4
	cpc R23,R5
	brlo L26
	.dbline 141
;    	  {
	.dbline 142
;    	  Tmp[0] = Str[0];
	ldd R2,y+11
	std y+4,R2
	.dbline 143
;    	  Tmp[1] = '.';
	ldi R24,46
	std y+5,R24
	.dbline 144
; 	  Tmp[2] = Str[1];
	ldd R2,y+12
	std y+6,R2
	.dbline 145
;    	  Tmp[3] = Str[2];	  
	ldd R2,y+13
	std y+7,R2
	.dbline 146
; 	  }
L26:
	.dbline 147
;    if (Count <= 100)
	ldi R20,100
	ldi R21,0
	ldi R22,0
	ldi R23,0
	lds R4,_Count+2
	lds R5,_Count+2+1
	lds R2,_Count
	lds R3,_Count+1
	cp R20,R2
	cpc R21,R3
	cpc R22,R4
	cpc R23,R5
	brlo L33
	.dbline 148
;    	  {
	.dbline 149
;    	  Tmp[0] = Str[0];
	ldd R2,y+11
	std y+4,R2
	.dbline 150
;    	  Tmp[1] = Str[1];
	ldd R2,y+12
	std y+5,R2
	.dbline 151
;    	  Tmp[2] = '.';
	ldi R24,46
	std y+6,R24
	.dbline 152
;    	  Tmp[3] = Str[2];
	ldd R2,y+13
	std y+7,R2
	.dbline 153
; 	  }	  
L33:
	.dbline 154
;    if (Count <= 10)
	ldi R20,10
	ldi R21,0
	ldi R22,0
	ldi R23,0
	lds R4,_Count+2
	lds R5,_Count+2+1
	lds R2,_Count
	lds R3,_Count+1
	cp R20,R2
	cpc R21,R3
	cpc R22,R4
	cpc R23,R5
	brlo L40
	.dbline 155
;    	  {
	.dbline 156
;    	  Tmp[0] = Str[0];
	ldd R2,y+11
	std y+4,R2
	.dbline 157
;    	  Tmp[1] = Str[1];
	ldd R2,y+12
	std y+5,R2
	.dbline 158
;    	  Tmp[2] = Str[2];
	ldd R2,y+13
	std y+6,R2
	.dbline 159
;    	  Tmp[3] = ' ';
	ldi R24,32
	std y+7,R24
	.dbline 160
; 	  }   	  
L40:
	.dbline 161
;    if (Count == 0)
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	lds R4,_Count+2
	lds R5,_Count+2+1
	lds R2,_Count
	lds R3,_Count+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brne L47
	.dbline 162
;    	  {
	.dbline 163
;    	  Tmp[0] = ' ';
	ldi R24,32
	std y+4,R24
	.dbline 164
;    	  Tmp[1] = ' ';
	std y+5,R24
	.dbline 165
;    	  Tmp[2] = '0';
	ldi R24,48
	std y+6,R24
	.dbline 166
;    	  Tmp[3] = ' ';
	ldi R24,32
	std y+7,R24
	.dbline 167
; 	  }   	  	  
L47:
	.dbline 168
;    Tmp[4] = 'm';
	ldi R24,109
	std y+8,R24
	.dbline 169
;    Tmp[5] = 's';
	ldi R24,115
	std y+9,R24
	.dbline 170
;    Tmp[6] = 0x00;
	clr R2
	std y+10,R2
	.dbline 171
;    LcdGotoXY(9,6);
	ldi R18,6
	ldi R16,9
	rcall _LcdGotoXY
	.dbline 172
;    LcdStr(1,&Tmp[0]);        
	movw R18,R28
	subi R18,252  ; offset = 4
	sbci R19,255
	ldi R16,1
	rcall _LcdStr
	.dbline 173
;    return;
	rjmp L20
L23:
	.dbline 176
;    }
;    
; if (Count < 10000)
	ldi R20,16
	ldi R21,39
	ldi R22,0
	ldi R23,0
	lds R4,_Count+2
	lds R5,_Count+2+1
	lds R2,_Count
	lds R3,_Count+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brlo X1
	rjmp L55
X1:
	.dbline 177
;    {
	.dbline 178
;    Tmp[0] = Str[0];
	ldd R2,y+11
	std y+4,R2
	.dbline 179
;    Tmp[1] = '.';
	ldi R24,46
	std y+5,R24
	.dbline 180
;    Tmp[2] = Str[1];
	ldd R2,y+12
	std y+6,R2
	.dbline 181
;    Tmp[3] = Str[2];
	ldd R2,y+13
	std y+7,R2
	.dbline 182
;    Tmp[4] = Str[3];
	ldd R2,y+14
	std y+8,R2
	.dbline 183
;    Tmp[5] = 0x00;
	clr R2
	std y+9,R2
	.dbline 184
;    LcdGotoXY(2,4);
	ldi R18,4
	ldi R16,2
	rcall _LcdGotoXY
	.dbline 185
;    LcdStr(2,&Tmp[0]);
	movw R18,R28
	subi R18,252  ; offset = 4
	sbci R19,255
	ldi R16,2
	rcall _LcdStr
	.dbline 186
;    LcdGotoXY(13,3);
	ldi R18,3
	ldi R16,13
	rcall _LcdGotoXY
	.dbline 187
;    LcdStr(1,"K" );
	ldi R18,<L65
	ldi R19,>L65
	ldi R16,1
	rcall _LcdStr
	.dbline 189
; 
;    Time = 1000000 / Count;
	lds R4,_Count+2
	lds R5,_Count+2+1
	lds R2,_Count
	lds R3,_Count+1
	ldi R20,64
	ldi R21,66
	ldi R22,15
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	rcall div32u
	sts _Time+1,R17
	sts _Time,R16
	sts _Time+2+1,R19
	sts _Time+2,R18
	.dbline 190
;    ltoa(&Str[0],Time,10);
	ldi R24,10
	ldi R25,0
	std y+2,R24
	std y+3,R25
	std y+0,R18
	std y+1,R19
	mov R18,R16
	mov R19,R17
	movw R16,R28
	subi R16,245  ; offset = 11
	sbci R17,255
	rcall _ltoa
	.dbline 191
;    Tmp[0] = Str[0];
	ldd R2,y+11
	std y+4,R2
	.dbline 192
;    Tmp[1] = Str[1];
	ldd R2,y+12
	std y+5,R2
	.dbline 193
;    Tmp[2] = Str[2];
	ldd R2,y+13
	std y+6,R2
	.dbline 194
;    Tmp[3] = ' ';
	ldi R24,32
	std y+7,R24
	.dbline 195
;    Tmp[4] = 'u';
	ldi R24,117
	std y+8,R24
	.dbline 196
;    Tmp[5] = 's';
	ldi R24,115
	std y+9,R24
	.dbline 197
;    Tmp[6] = 0x00;
	clr R2
	std y+10,R2
	.dbline 198
;    LcdGotoXY(9,6);
	ldi R18,6
	ldi R16,9
	rcall _LcdGotoXY
	.dbline 199
;    LcdStr(1,&Tmp[0]);         
	movw R18,R28
	subi R18,252  ; offset = 4
	sbci R19,255
	ldi R16,1
	rcall _LcdStr
	.dbline 200
;    return;   
	rjmp L20
L55:
	.dbline 203
;    }
;    
; if (Count < 100000)
	ldi R20,160
	ldi R21,134
	ldi R22,1
	ldi R23,0
	lds R4,_Count+2
	lds R5,_Count+2+1
	lds R2,_Count
	lds R3,_Count+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brlo X2
	rjmp L74
X2:
	.dbline 204
;    {
	.dbline 205
;    Tmp[0] = Str[0];
	ldd R2,y+11
	std y+4,R2
	.dbline 206
;    Tmp[1] = Str[1];
	ldd R2,y+12
	std y+5,R2
	.dbline 207
;    Tmp[2] = '.';
	ldi R24,46
	std y+6,R24
	.dbline 208
;    Tmp[3] = Str[2];
	ldd R2,y+13
	std y+7,R2
	.dbline 209
;    Tmp[4] = Str[3];
	ldd R2,y+14
	std y+8,R2
	.dbline 210
;    Tmp[5] = Str[4];
	ldd R2,y+15
	std y+9,R2
	.dbline 211
;    Tmp[6] = 0x00;
	clr R2
	std y+10,R2
	.dbline 212
;    LcdGotoXY(1,4);
	ldi R18,4
	ldi R16,1
	rcall _LcdGotoXY
	.dbline 213
;    LcdStr(2,&Tmp[0]);
	movw R18,R28
	subi R18,252  ; offset = 4
	sbci R19,255
	ldi R16,2
	rcall _LcdStr
	.dbline 214
;    LcdGotoXY(13,3);
	ldi R18,3
	ldi R16,13
	rcall _LcdGotoXY
	.dbline 215
;    LcdStr(1,"K" );
	ldi R18,<L65
	ldi R19,>L65
	ldi R16,1
	rcall _LcdStr
	.dbline 217
;    
;    Time = 10000000 / Count;
	lds R4,_Count+2
	lds R5,_Count+2+1
	lds R2,_Count
	lds R3,_Count+1
	ldi R20,128
	ldi R21,150
	ldi R22,152
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	rcall div32u
	sts _Time+1,R17
	sts _Time,R16
	sts _Time+2+1,R19
	sts _Time+2,R18
	.dbline 218
;    ltoa(&Str[0],Time,10);
	ldi R24,10
	ldi R25,0
	std y+2,R24
	std y+3,R25
	std y+0,R18
	std y+1,R19
	mov R18,R16
	mov R19,R17
	movw R16,R28
	subi R16,245  ; offset = 11
	sbci R17,255
	rcall _ltoa
	.dbline 219
;    Tmp[0] = Str[0];
	ldd R2,y+11
	std y+4,R2
	.dbline 220
;    Tmp[1] = Str[1];
	ldd R2,y+12
	std y+5,R2
	.dbline 221
;    Tmp[2] = '.';
	ldi R24,46
	std y+6,R24
	.dbline 222
;    Tmp[3] = Str[2];
	ldd R2,y+13
	std y+7,R2
	.dbline 223
;    Tmp[4] = 'u';
	ldi R24,117
	std y+8,R24
	.dbline 224
;    Tmp[5] = 's';
	ldi R24,115
	std y+9,R24
	.dbline 225
;    Tmp[6] = 0x00;
	clr R2
	std y+10,R2
	.dbline 226
;    LcdGotoXY(9,6);
	ldi R18,6
	ldi R16,9
	rcall _LcdGotoXY
	.dbline 227
;    LcdStr(1,&Tmp[0]);      
	movw R18,R28
	subi R18,252  ; offset = 4
	sbci R19,255
	ldi R16,1
	rcall _LcdStr
	.dbline 228
;    return;      
	rjmp L20
L74:
	.dbline 231
;    }
;    
; if (Count < 1000000)
	ldi R20,64
	ldi R21,66
	ldi R22,15
	ldi R23,0
	lds R4,_Count+2
	lds R5,_Count+2+1
	lds R2,_Count
	lds R3,_Count+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brlo X3
	rjmp L94
X3:
	.dbline 232
;    {
	.dbline 233
;    Tmp[0] = Str[0];
	ldd R2,y+11
	std y+4,R2
	.dbline 234
;    Tmp[1] = Str[1];
	ldd R2,y+12
	std y+5,R2
	.dbline 235
;    Tmp[2] = Str[2];
	ldd R2,y+13
	std y+6,R2
	.dbline 236
;    Tmp[3] = '.';
	ldi R24,46
	std y+7,R24
	.dbline 237
;    Tmp[4] = Str[3];
	ldd R2,y+14
	std y+8,R2
	.dbline 238
;    Tmp[5] = Str[4];
	ldd R2,y+15
	std y+9,R2
	.dbline 239
;    Tmp[6] = 0x00;
	clr R2
	std y+10,R2
	.dbline 240
;    LcdGotoXY(1,4);
	ldi R18,4
	ldi R16,1
	rcall _LcdGotoXY
	.dbline 241
;    LcdStr(2,&Tmp[0]);
	movw R18,R28
	subi R18,252  ; offset = 4
	sbci R19,255
	ldi R16,2
	rcall _LcdStr
	.dbline 242
;    LcdGotoXY(13,3);
	ldi R18,3
	ldi R16,13
	rcall _LcdGotoXY
	.dbline 243
;    LcdStr(1,"K" );
	ldi R18,<L65
	ldi R19,>L65
	ldi R16,1
	rcall _LcdStr
	.dbline 245
;    
;    Time = 100000000 / Count;
	lds R4,_Count+2
	lds R5,_Count+2+1
	lds R2,_Count
	lds R3,_Count+1
	ldi R20,0
	ldi R21,225
	ldi R22,245
	ldi R23,5
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	rcall div32u
	sts _Time+1,R17
	sts _Time,R16
	sts _Time+2+1,R19
	sts _Time+2,R18
	.dbline 246
;    ltoa(&Str[0],Time,10);
	ldi R24,10
	ldi R25,0
	std y+2,R24
	std y+3,R25
	std y+0,R18
	std y+1,R19
	mov R18,R16
	mov R19,R17
	movw R16,R28
	subi R16,245  ; offset = 11
	sbci R17,255
	rcall _ltoa
	.dbline 247
;    Tmp[0] = Str[0];
	ldd R2,y+11
	std y+4,R2
	.dbline 248
;    Tmp[1] = '.';
	ldi R24,46
	std y+5,R24
	.dbline 249
;    Tmp[2] = Str[1];
	ldd R2,y+12
	std y+6,R2
	.dbline 250
;    Tmp[3] = Str[2];
	ldd R2,y+13
	std y+7,R2
	.dbline 251
;    Tmp[4] = 'u';
	ldi R24,117
	std y+8,R24
	.dbline 252
;    Tmp[5] = 's';
	ldi R24,115
	std y+9,R24
	.dbline 253
;    Tmp[6] = 0x00;
	clr R2
	std y+10,R2
	.dbline 254
;    LcdGotoXY(9,6);
	ldi R18,6
	ldi R16,9
	rcall _LcdGotoXY
	.dbline 255
;    LcdStr(1,&Tmp[0]);   
	movw R18,R28
	subi R18,252  ; offset = 4
	sbci R19,255
	ldi R16,1
	rcall _LcdStr
	.dbline 256
;    return;         
	rjmp L20
L94:
	.dbline 259
	ldi R20,128
	ldi R21,150
	ldi R22,152
	ldi R23,0
	lds R4,_Count+2
	lds R5,_Count+2+1
	lds R2,_Count
	lds R3,_Count+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brlo X4
	rjmp L114
X4:
	.dbline 260
	.dbline 261
	ldd R2,y+11
	std y+4,R2
	.dbline 262
	ldi R24,46
	std y+5,R24
	.dbline 263
	ldd R2,y+12
	std y+6,R2
	.dbline 264
	ldd R2,y+13
	std y+7,R2
	.dbline 265
	ldd R2,y+14
	std y+8,R2
	.dbline 266
	ldd R2,y+15
	std y+9,R2
	.dbline 267
	clr R2
	std y+10,R2
	.dbline 268
	ldi R18,4
	ldi R16,1
	rcall _LcdGotoXY
	.dbline 269
	movw R18,R28
	subi R18,252  ; offset = 4
	sbci R19,255
	ldi R16,2
	rcall _LcdStr
	.dbline 270
	ldi R18,3
	ldi R16,13
	rcall _LcdGotoXY
	.dbline 271
	ldi R18,<L126
	ldi R19,>L126
	ldi R16,1
	rcall _LcdStr
	.dbline 273
	lds R4,_Count+2
	lds R5,_Count+2+1
	lds R2,_Count
	lds R3,_Count+1
	ldi R20,0
	ldi R21,202
	ldi R22,154
	ldi R23,59
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	rcall div32u
	sts _Time+1,R17
	sts _Time,R16
	sts _Time+2+1,R19
	sts _Time+2,R18
	.dbline 274
	ldi R24,10
	ldi R25,0
	std y+2,R24
	std y+3,R25
	std y+0,R18
	std y+1,R19
	mov R18,R16
	mov R19,R17
	movw R16,R28
	subi R16,245  ; offset = 11
	sbci R17,255
	rcall _ltoa
	.dbline 275
	ldd R2,y+11
	std y+4,R2
	.dbline 276
	ldd R2,y+12
	std y+5,R2
	.dbline 277
	ldd R2,y+13
	std y+6,R2
	.dbline 278
	ldi R24,32
	std y+7,R24
	.dbline 279
	ldi R24,110
	std y+8,R24
	.dbline 280
	ldi R24,115
	std y+9,R24
	.dbline 281
	clr R2
	std y+10,R2
	.dbline 282
	ldi R18,6
	ldi R16,9
	rcall _LcdGotoXY
	.dbline 283
	movw R18,R28
	subi R18,252  ; offset = 4
	sbci R19,255
	ldi R16,1
	rcall _LcdStr
	.dbline 285
L114:
	.dbline -2
	.dbline 287
;    }
;    
; if (Count < 10000000)
;    {
;    Tmp[0] = Str[0];
;    Tmp[1] = '.';
;    Tmp[2] = Str[1];
;    Tmp[3] = Str[2];
;    Tmp[4] = Str[3];
;    Tmp[5] = Str[4];
;    Tmp[6] = 0x00;
;    LcdGotoXY(1,4);
;    LcdStr(2,&Tmp[0]);
;    LcdGotoXY(13,3);
;    LcdStr(1,"M" );
;    
;    Time = 1000000000 / Count;
;    ltoa(&Str[0],Time,10);
;    Tmp[0] = Str[0];
;    Tmp[1] = Str[1];
;    Tmp[2] = Str[2];
;    Tmp[3] = ' ';
;    Tmp[4] = 'n';
;    Tmp[5] = 's';
;    Tmp[6] = 0x00;   
;    LcdGotoXY(9,6);
;    LcdStr(1,&Tmp[0]);
;    
;    return;          
;    }
; }
L20:
	adiw R28,18
	rcall pop_gset3
	.dbline 0 ; func end
	ret
	.dbsym r Len 10 c
	.dbsym l Str 11 A[7:7]c
	.dbsym l Tmp 4 A[7:7]c
	.dbend
	.dbfunc e Presentation _Presentation fV
;              i -> R20
	.even
_Presentation::
	rcall push_gset1
	sbiw R28,5
	.dbline -1
	.dbline 291
; 
; /*********************************************************/
; void Presentation(void)
; {
	.dbline 294
; unsigned char i;
; 
; LcdClear();
	rcall _LcdClear
	.dbline 295
; LcdUpdate();
	rcall _LcdUpdate
	.dbline 297
; 
; LcdGotoXY(3,1);
	ldi R18,1
	ldi R16,3
	rcall _LcdGotoXY
	.dbline 298
; LcdStr(1,"Freq Meter" );
	ldi R18,<L136
	ldi R19,>L136
	ldi R16,1
	rcall _LcdStr
	.dbline 299
	clr R20
	rjmp L140
L137:
	.dbline 299
	ldi R24,2
	std y+4,R24
	std y+2,R20
	ldi R24,83
	std y+0,R24
	mov R18,R20
	clr R16
	rcall _LcdLine
L138:
	.dbline 299
	inc R20
L140:
	.dbline 299
; for (i=0;i<9;i++) LcdLine(0,i,83,i,PIXEL_XOR);
	cpi R20,9
	brlo L137
	.dbline 300
; LcdGotoXY(5,3);
	ldi R18,3
	ldi R16,5
	rcall _LcdGotoXY
	.dbline 301
; LcdStr(1,"Sylvain");
	ldi R18,<L141
	ldi R19,>L141
	ldi R16,1
	rcall _LcdStr
	.dbline 302
; LcdGotoXY(3,4);
	ldi R18,4
	ldi R16,3
	rcall _LcdGotoXY
	.dbline 303
; LcdStr(1,"Bissonnette");
	ldi R18,<L142
	ldi R19,>L142
	ldi R16,1
	rcall _LcdStr
	.dbline 304
; LcdGotoXY(4,6);
	ldi R18,6
	ldi R16,4
	rcall _LcdGotoXY
	.dbline 305
; LcdStr(1,"Ver : 1.0");
	ldi R18,<L143
	ldi R19,>L143
	ldi R16,1
	rcall _LcdStr
	.dbline 306
; LcdUpdate();
	rcall _LcdUpdate
	.dbline 307
; Delay(10000);
	ldi R16,10000
	ldi R17,39
	rcall _Delay
	.dbline 308
; LcdClear();
	rcall _LcdClear
	.dbline 309
; LcdUpdate();
	rcall _LcdUpdate
	.dbline -2
	.dbline 310
; }
L135:
	adiw R28,5
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r i 20 c
	.dbend
	.dbfunc e main _main fV
;              i -> R20
	.even
_main::
	sbiw R28,5
	.dbline -1
	.dbline 314
; 
; /*********************************************************/
; void main(void)
; {
	.dbline 317
; unsigned char i;
; 
; LcdInit();
	rcall _LcdInit
	.dbline 318
; LcdClear();
	rcall _LcdClear
	.dbline 319
; LcdUpdate();
	rcall _LcdUpdate
	.dbline 321
; 
; Presentation();
	rcall _Presentation
	.dbline 323
; 
; LcdGotoXY(3,1);
	ldi R18,1
	ldi R16,3
	rcall _LcdGotoXY
	.dbline 324
; LcdStr(1,"Freq Meter" );
	ldi R18,<L136
	ldi R19,>L136
	ldi R16,1
	rcall _LcdStr
	.dbline 325
	clr R20
	rjmp L148
L145:
	.dbline 325
	ldi R24,2
	std y+4,R24
	std y+2,R20
	ldi R24,83
	std y+0,R24
	mov R18,R20
	clr R16
	rcall _LcdLine
L146:
	.dbline 325
	inc R20
L148:
	.dbline 325
; for (i=0;i<9;i++) LcdLine(0,i,83,i,PIXEL_XOR);
	cpi R20,9
	brlo L145
	.dbline 327
; 
; LcdGotoXY(12,4);
	ldi R18,4
	ldi R16,12
	rcall _LcdGotoXY
	.dbline 328
; LcdStr(1," hz" );
	ldi R18,<L149
	ldi R19,>L149
	ldi R16,1
	rcall _LcdStr
	.dbline 329
; LcdGotoXY(2,4);
	ldi R18,4
	ldi R16,2
	rcall _LcdGotoXY
	.dbline 330
; LcdStr(2,"    0");
	ldi R18,<L150
	ldi R19,>L150
	ldi R16,2
	rcall _LcdStr
	.dbline 331
; LcdGotoXY(1,6);
	ldi R18,6
	ldi R16,1
	rcall _LcdGotoXY
	.dbline 332
; LcdStr(1,"Period: " );
	ldi R18,<L151
	ldi R19,>L151
	ldi R16,1
	rcall _LcdStr
	.dbline 334
; 
; TCCR0 = 0x05; //start timer0 / 1024
	ldi R24,5
	out 0x33,R24
	.dbline 336
; 
; DDRB = 0x3f;
	ldi R24,63
	out 0x17,R24
	.dbline 337
; DDRC = 0x00;
	clr R2
	out 0x14,R2
	.dbline 338
; DDRD = 0x3e;
	ldi R24,62
	out 0x11,R24
	.dbline 340
; 
; PORTD |= OEH;
	sbi 0x12,4
	.dbline 341
; PORTD |= OEM;
	sbi 0x12,3
	.dbline 342
; PORTD |= OEL;
	sbi 0x12,2
	.dbline 343
; PORTD |= CLR;
	sbi 0x12,5
	.dbline 349
; 
; //TIMER1 initialisation - prescale:256
; // WGM: 4) CTC, TOP=OCRnA
; // desired value: 2000mSec
; // actual value: 2000.000mSec (0.0%)
; TCCR1B = 0x00; 
	out 0x2e,R2
	.dbline 350
; OCR1AH = 0x7A;
	ldi R24,122
	out 0x2b,R24
	.dbline 351
; OCR1AL = 0x11;
	ldi R24,17
	out 0x2a,R24
	.dbline 352
; TCCR1A = 0x40;
	ldi R24,64
	out 0x2f,R24
	.dbline 353
; TCCR1B = 0x0C; 
	ldi R24,12
	out 0x2e,R24
	.dbline 355
; 
; TIMSK = 0x11; //timer interrupt sources
	ldi R24,17
	out 0x39,R24
	.dbline 356
; SEI(); //re-enable interrupts
	sei
	rjmp L153
L152:
	.dbline 358
	.dbline 359
	ldi R16,10
	ldi R17,0
	rcall _Delay
	.dbline 360
L153:
	.dbline 357
	rjmp L152
X5:
	.dbline -2
	.dbline 361
; while(1)
; 		{
; 		Delay(10);
; 		}
; }
L144:
	adiw R28,5
	.dbline 0 ; func end
	ret
	.dbsym r i 20 c
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DATA\FrequancyCounter\Code\FMeter.c
_Time::
	.blkb 4
	.dbsym e Time _Time l
_Count::
	.blkb 4
	.dbsym e Count _Count l
	.area data(ram, con, rel)
	.dbfile C:\DATA\FrequancyCounter\Code\FMeter.c
L151:
	.blkb 9
	.area idata
	.byte 'P,'e,'r,'i,'o,'d,58,32,0
	.area data(ram, con, rel)
	.dbfile C:\DATA\FrequancyCounter\Code\FMeter.c
L150:
	.blkb 6
	.area idata
	.byte 32,32,32,32,48,0
	.area data(ram, con, rel)
	.dbfile C:\DATA\FrequancyCounter\Code\FMeter.c
L149:
	.blkb 4
	.area idata
	.byte 32,'h,'z,0
	.area data(ram, con, rel)
	.dbfile C:\DATA\FrequancyCounter\Code\FMeter.c
L143:
	.blkb 10
	.area idata
	.byte 'V,'e,'r,32,58,32,49,46,48,0
	.area data(ram, con, rel)
	.dbfile C:\DATA\FrequancyCounter\Code\FMeter.c
L142:
	.blkb 12
	.area idata
	.byte 'B,'i,'s,'s,'o,'n,'n,'e,'t,'t,'e,0
	.area data(ram, con, rel)
	.dbfile C:\DATA\FrequancyCounter\Code\FMeter.c
L141:
	.blkb 8
	.area idata
	.byte 'S,'y,'l,'v,'a,'i,'n,0
	.area data(ram, con, rel)
	.dbfile C:\DATA\FrequancyCounter\Code\FMeter.c
L136:
	.blkb 11
	.area idata
	.byte 'F,'r,'e,'q,32,'M,'e,'t,'e,'r,0
	.area data(ram, con, rel)
	.dbfile C:\DATA\FrequancyCounter\Code\FMeter.c
L126:
	.blkb 2
	.area idata
	.byte 'M,0
	.area data(ram, con, rel)
	.dbfile C:\DATA\FrequancyCounter\Code\FMeter.c
L65:
	.blkb 2
	.area idata
	.byte 'K,0
	.area data(ram, con, rel)
	.dbfile C:\DATA\FrequancyCounter\Code\FMeter.c
L25:
	.blkb 2
	.area idata
	.byte 32,0
	.area data(ram, con, rel)
	.dbfile C:\DATA\FrequancyCounter\Code\FMeter.c
L22:
	.blkb 6
	.area idata
	.byte 32,32,32,32,32,0
	.area data(ram, con, rel)
	.dbfile C:\DATA\FrequancyCounter\Code\FMeter.c
L21:
	.blkb 7
	.area idata
	.byte 32,32,32,32,32,32,0
	.area data(ram, con, rel)
	.dbfile C:\DATA\FrequancyCounter\Code\FMeter.c
